HDU 1026 Ignatius and the Princess I (bfs + 优先队列 + 路径记录)

13 篇文章 0 订阅
5 篇文章 0 订阅

HDU 1026


通过记录前驱来记录路径,不用担心所记录的路径不是用时最少的路径,因为优先队列每次出队的都是用时最少的元素,所以当不合适的元素出队时,正确的路径早已被标记完了。 另外,(0, 0)点确实是没有怪兽的。


#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <queue>
using namespace std;
char map[110][110];
int vis[110][110];
int dir[4][2] = {1, 0, 0, 1, -1, 0, 0, -1};
int N, M;
struct node {
	int x, y;
	int time;
	friend bool operator < (node a, node b) {
		return a.time > b.time;
	}
};
int pre[110][110];
int t;
int bfs() {
	int i, j;
	priority_queue<node> q;
	node now, next;
	now.x = 0, now.y = 0, now.time = 0;
	q.push(now);
	while(!q.empty()) {
		now = q.top();
		q.pop();
		if(now.x == N - 1 && now.y == M - 1) {
			return now.time;
		}
		vis[now.x][now.y] = 1;
		for(i = 0; i < 4; i++) {
			next.x = now.x + dir[i][0];
			next.y = now.y + dir[i][1];
			if(next.x >= 0 && next.x <= N - 1 && next.y >= 0 && next.y <= M - 1) {
				if(vis[next.x][next.y] == 0 && map[next.x][next.y] != 'X') {
					if(map[next.x][next.y] == '.') {
						next.time = now.time + 1;
					}
					else if(map[next.x][next.y] >= '1' && map[next.x][next.y] <= '9') {
						next.time = now.time + map[next.x][next.y] - '0' + 1;
					}
					vis[next.x][next.y] = 1;
					pre[next.x][next.y] = i;
					q.push(next);
				}
			}
		}
	}
	return -1;
}
void path(int x, int y) {
	if(x == 0 && y == 0) {
		return;
	}
	int tx = x - dir[pre[x][y]][0];
	int ty = y - dir[pre[x][y]][1];
	path(tx, ty);
	printf("%ds:(%d,%d)->(%d,%d)\n", t++, tx, ty, x, y);
	if(map[x][y] >= '1' && map[x][y] <= '9') {
		int i;
		for(i = 1; i <= map[x][y] - '0'; i++) {
			printf("%ds:FIGHT AT (%d,%d)\n", t++, x, y);
		}
	}
}
int main() {
	while(~scanf("%d %d", &N, &M)) {
		getchar();
		int i, j;
		for(i = 0; i < N; i++) {
			for(j = 0; j < M; j++) {
				scanf("%c", &map[i][j]);
			}
			getchar();
		}
		memset(vis, 0, sizeof(vis));
		memset(pre, 0, sizeof(pre));
		int step = bfs();
		if(step != -1) {
			printf("It takes %d seconds to reach the target position, let me show you the way.\n", step);
			t = 1;
			path(N - 1, M - 1);
		}
		else {
			printf("God please help our poor hero.\n");
		}
		printf("FINISH\n");
	}
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
对于HDU4546问题,还可以使用优先队列(Priority Queue)来解决。以下是使用优先队列的解法思路: 1. 首先,将数组a进行排序,以便后续处理。 2. 创建一个优先队列(最小堆),用于存储组合之和的候选值。 3. 初始化优先队列,将初始情况(即前0个数的组合之和)加入队列。 4. 开始从1到n遍历数组a的元素,对于每个元素a[i],将当前队列中的所有候选值取出,分别加上a[i],然后再将加和的结果作为新的候选值加入队列。 5. 重复步骤4直到遍历完所有元素。 6. 当队列的大小超过k时,将队列中的最小值弹出。 7. 最后,队列中的所有候选值之和即为前k小的组合之和。 以下是使用优先队列解决HDU4546问题的代码示例: ```cpp #include <iostream> #include <vector> #include <queue> #include <functional> using namespace std; int main() { int n, k; cin >> n >> k; vector<int> a(n); for (int i = 0; i < n; i++) { cin >> a[i]; } sort(a.begin(), a.end()); // 对数组a进行排序 priority_queue<long long, vector<long long>, greater<long long>> pq; // 最小堆 pq.push(0); // 初始情况,前0个数的组合之和为0 for (int i = 0; i < n; i++) { long long num = pq.top(); // 取出当前队列中的最小值 pq.pop(); for (int j = i + 1; j <= n; j++) { pq.push(num + a[i]); // 将所有加和结果作为新的候选值加入队列 num += a[i]; } if (pq.size() > k) { pq.pop(); // 当队列大小超过k时,弹出最小值 } } long long sum = 0; while (!pq.empty()) { sum += pq.top(); // 求队列中所有候选值之和 pq.pop(); } cout << sum << endl; return 0; } ``` 使用优先队列的方法可以有效地找到前k小的组合之和,时间复杂度为O(nklog(k))。希望这个解法对你有所帮助!
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值